unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IdBaseComponent, IdComponent, IdTCPServer, IdServerIOHandler,
  IdSSLOpenSSL, StdCtrls;

type
  TMainForm = class(TForm)
    Server: TIdTCPServer;
    chkbSSL: TCheckBox;
    ServerSSL: TIdServerIOHandlerSSL;
    procedure ServerExecute(AThread: TIdPeerThread);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ServerConnect(AThread: TIdPeerThread);
    procedure chkbSSLClick(Sender: TObject);
  protected
    GCertificatePath: string;
    procedure SetSSLOptions;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.ServerExecute(AThread: TIdPeerThread);
var
  LCmd: string;
begin
  with AThread.Connection do begin
    LCmd := ReadLn;
    if AnsiSameText(LCmd, 'Version') then begin
      WriteLn('Server Version: 1.0');
    end else if AnsiSameText(LCmd, 'SSL') then begin
      WriteLn('SSL Version: 3.0');
    end else if AnsiSameText(LCmd, 'QUIT') then begin
      WriteLn('Goodybe');
      Disconnect;
    end else begin
      WriteLn('Unkown command');
    end;
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  GCertificatePath := ExtractFilePath(ParamStr(0)) + '\Certificates\';
  SetSSLOptions;
  Server.Active := True;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Server.Active := False;
end;

procedure TMainForm.SetSSLOptions;
begin
  with ServerSSL.SSLOptions do begin
    RootCertFile := GCertificatePath + 'IntelicomCACrt.pem';
    CertFile := GCertificatePath + 'IndyServerCrt.pem';
    KeyFile := GCertificatePath + 'IndyServerKey.pem';
    Method := sslvSSLv3;
    Mode := sslmServer;
  end;
end;

procedure TMainForm.ServerConnect(AThread: TIdPeerThread);
begin
  AThread.Connection.WriteLn('Welcome to SecureServer');
end;

procedure TMainForm.chkbSSLClick(Sender: TObject);
begin
  if Server.Active then begin
    Server.Active := False;
  end;
  if chkbSSL.Checked then begin
    Server.IOHandler := ServerSSL;
  end else begin
    Server.IOHandler := nil;
  end;
  Server.Active := True;
end;

end.
